package PC20060626;

import ProSW.*;
import java.util.*;

public abstract class Piatto {
	private final String nome;
	public String getNome() { return nome; }
	
	private int minutiPreparazione;
	
	public int getMinutiPreparazione() { 
		return minutiPreparazione; 
	}
	public void setMinutiPreparazione(int m) throws EccezionePrecondizioni {
		if (m < 0) throw new EccezionePrecondizioni("...");
		minutiPreparazione = m;
	}
	
	public Piatto(String n, int min) throws EccezionePrecondizioni {
		if (n == null) throw new EccezionePrecondizioni("...");
		nome = n;
		setMinutiPreparazione(min);
	}

	// GESTIONE ASSOCIAZIONE INGREDIENTE (1..*)
	private Set<TipoLinkIngrediente> insLinkIngrediente = new HashSet<TipoLinkIngrediente>();
	
	public void inserisciLinkIngrediente(AssociazioneIngrediente pass, TipoLinkIngrediente l) throws EccezionePrecondizioni {
		if (pass == null) throw new EccezionePrecondizioni("...");
		
		insLinkIngrediente.add(l);
	}

	public void eliminaLinkIngrediente(AssociazioneIngrediente pass, TipoLinkIngrediente l) throws EccezionePrecondizioni {
		if (pass == null) throw new EccezionePrecondizioni("...");
		
		insLinkIngrediente.remove(l);
	}
		
	public Set<TipoLinkIngrediente> getLinkIngrediente() throws EccezioneMolteplicita {
		if (insLinkIngrediente.size() < 1) throw new EccezioneMolteplicita("Vincolo 1..* violato");
		return (Set<TipoLinkIngrediente>)((HashSet<TipoLinkIngrediente>)insLinkIngrediente).clone();
	}


	// GESTIONE ASSOCIAZIONE ingredienteCaratterizzante (1..3)
	private Set<Alimento> insLinkIngredienteCar = new HashSet<Alimento>();
	
	public void inserisciLinkIngredienteCar(Alimento a) throws EccezionePrecondizioni, EccezioneMolteplicita {
		if (a == null) throw new EccezionePrecondizioni("...");
		
		// Controllo vincolo "subset":  <this, a> deve essere in ingrediente
		if (!this.getLinkIngrediente().contains( new TipoLinkIngrediente(this, a, 1) ) )
			throw new EccezionePrecondizioni("Vincolo subset non soddisfatto");
			
		insLinkIngredienteCar.add(a);
	}

	public void eliminaLinkIngredienteCar(Alimento a ) throws EccezionePrecondizioni {
		if (a == null) throw new EccezionePrecondizioni("...");

		insLinkIngredienteCar.remove(a);
	}
		
	public Set<Alimento> getLinkIngredienteCar() throws EccezioneMolteplicita {
		if (insLinkIngredienteCar.size() < 1 || insLinkIngredienteCar.size() > 3) throw new EccezioneMolteplicita("Vincolo 1..3 violato");
		return (Set<Alimento>)((HashSet<Alimento>)insLinkIngredienteCar).clone();
	}



	// OPERAZIONI DI CLASSE

	public boolean compatibileCon(Piatto altro) { 
		/* ... */
		return true;
	}
	
	public double kcal() {
		/* ... */
		return 0;
	}
	
} //:~
