package PC20060626;

import ProSW.*;
import java.util.*;

public class TipologiaAlimento {
	private final String nome;
	public String getNome() { return nome; }
	

	public TipologiaAlimento(String n) throws EccezionePrecondizioni {
		if (n == null) throw new EccezionePrecondizioni("...");
		nome = n;
	}



	// GESTIONE ASSOCIAZIONE incompatibileT
	/* Nota: realizzata in modo semplificato, come Alimento.incompatibileA, per le stesse ragioni
	*/
	
	// Un insieme di tipologie, come se l'assoc fosse a resp. singola...
	private Set<TipologiaAlimento> insLinkIncompatibileT = new HashSet<TipologiaAlimento>();
	
	
	public void inserisciLinkIncompatibileT(TipologiaAlimento t) throws EccezionePrecondizioni {
		if (t == null) throw new EccezionePrecondizioni("...");
		
		// Inserimento "simmetrico", come se l'assoc fosse a resp. doppia
		t.insLinkIncompatibileT.add(this);
		this.insLinkIncompatibileT.add(t);
	}

	public void eliminaLinkIncompatibileT(TipologiaAlimento t) throws EccezionePrecondizioni {
		if (t == null) throw new EccezionePrecondizioni("...");
		
		this.insLinkIncompatibileT.remove(t);
		t.insLinkIncompatibileT.remove(this);
	}

	public Set<TipologiaAlimento> getTipologieIncompatibili() {
		return (Set<TipologiaAlimento>)((HashSet<TipologiaAlimento>)insLinkIncompatibileT).clone();
	}

	public boolean compatibileCon(TipologiaAlimento altra) throws EccezionePrecondizioni { 
		if (altra == null) throw new EccezionePrecondizioni("...");
		
		if (this.insLinkIncompatibileT.contains(altra)) return false;
		return true;
	}
	
	
} //:~